import React from 'react';
import { render } from 'react-dom';
import { HashRouter as Router, Route } from 'react-router-dom';
import { Provider } from 'react-redux';
import getPageProxy from './page-proxy';
import configureStore from './configure-store';

var Bootstrap =
/*#__PURE__*/
function () {
  function Bootstrap() {}

  var _proto = Bootstrap.prototype;

  _proto.getMountTarget = function getMountTarget(node) {
    if (node === void 0) {
      node = 'bsMain';
    }

    if (this.mountTarget instanceof HTMLElement) return this.mountTarget;
    if (node instanceof HTMLElement) return node;

    if (typeof node === 'string') {
      return document.querySelector(node);
    }

    throw new Error('挂载点即不是dom对象，也不是querySelector可选择的字符串，请检测项目配置');
  };

  _proto.initPageProxy = function initPageProxy(layout, pageLoader) {
    if (this.pageProxy) return this.pageProxy;
    return getPageProxy(layout, pageLoader);
  }
  /**
   *
   * @param {function | object} options.reducer - redux reducer
   * @param {string | HTMLElement} options.el - 应用的挂载点
   * @param {function} options.afterCreateStore - 创建完store之后的回调
   * @param {React.ComponentClass} options.layout - 布局组件
   * @param {function} options.pageLoader - 加载页面的方法
   */
  ;

  _proto.config = function config(options) {
    this.reduxStore = configureStore(options);
    this.mountTarget = this.getMountTarget(options.el);
    this.pageProxy = this.initPageProxy(options.layout, options.pageLoader);
  };

  _proto.start = function start() {
    render(React.createElement(Provider, {
      store: this.reduxStore
    }, React.createElement(Router, null, React.createElement(Route, {
      path: "*",
      component: this.pageProxy
    }))), this.mountTarget);
  };

  return Bootstrap;
}();

var app = new Bootstrap();
export { app as default };

if (module.hot) {
  module.hot.accept('./page-proxy', function () {
    app.start();
  }); //   module.hot.accept('_/src/reducers', () => {
  //     let reducer = require('_/src/reducers').default;
  //     store.replaceReducer(composeReducer(reducer));
  //   });
}