import "core-js/modules/es6.promise";
import "core-js/modules/web.dom.iterable";
import "core-js/modules/es6.array.iterator";
import "core-js/modules/es6.object.to-string";
import "core-js/modules/es6.string.iterator";
import "core-js/modules/es6.regexp.match";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import React, { Component } from 'react';
var currentPage = '$$currentPage';
var df = 'default';
export default function getPageProxy(Layout, pageLoader) {
  var _temp;

  return _temp =
  /*#__PURE__*/
  function (_Component) {
    _inheritsLoose(PageProxy, _Component);

    function PageProxy() {
      var _this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _Component.call.apply(_Component, [this].concat(args)) || this;
      _this.state = {};
      return _this;
    }

    var _proto = PageProxy.prototype;

    _proto.getPagePath = function getPagePath(props) {
      var _ref = props || this.props,
          url = _ref.match.url;

      return url.substr(1) || 'home';
    };

    _proto.componentDidMount = function componentDidMount() {
      this.loadAsyncPages(this.getPagePath(this.props));
    };

    _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
      var currentPath = this.getPagePath(this.props);
      var nextPath = this.getPagePath(nextProps);

      if (currentPath !== nextPath) {
        this.loadAsyncPages(nextPath);
      }
    };

    _proto.renderPageElement = function renderPageElement() {
      var state = this.state;
      var pagePath = this.getPagePath(this.props);
      var PageComponent = state[pagePath];
      return !!PageComponent ? React.createElement(PageComponent, this.props) : React.createElement("div", null, "loading...");
    };

    _proto.render = function render() {
      var pageElement = this.renderPageElement();
      if (Layout) return React.createElement(Layout, this.props, pageElement);
      return pageElement;
    };

    _proto.warn = function warn(msg, err) {
      if (console && console.error) {
        console.error(msg);
        throw err;
      }

      ;
    };

    _proto.loadAsyncPages = function loadAsyncPages(path) {
      var _this2 = this;

      var loadPage = this.state[path] ? undefined : pageLoader(path);
      Promise.all([loadPage]).then(function (_ref2) {
        var PageComponent = _ref2[0];
        var needUpdate = false;
        var updateData = {};

        if (PageComponent) {
          needUpdate = true;
          updateData[path] = PageComponent[df];
        }

        if (_this2.state[currentPage] !== path) {
          needUpdate = true;
          updateData[currentPage] = path;
        }

        if (needUpdate) {
          _this2.setState(updateData);
        }
      }).catch(function (err) {
        _this2.warn("\u9875\u9762 " + path + " \u52A0\u8F7D\u5931\u8D25", err);
      });
    };

    return PageProxy;
  }(Component), _temp;
}